<div class="card bg-light">
  
  <div class="card-header">Ticket: {{factura.descripcion}}</div>
  <div  class="d-flex justify-content-end">
    <button class="btn btn-primary btn-sm  m-2" type="button" [disabled]="disabledApertura"   (click)="open(mymodal)" >Apertura Caja</button>
    <button class="btn btn-primary btn-sm  m-2" type="button" [disabled]="disabledCierre"  (click)="openCierre(mymodalcierre)" >  Cierre Caja</button>

  </div>
  <div class="card-body" >
    <!--h4 class="card-title">
      <a [routerLink]="['/clientes']" class="btn btn-light btn-xs">&laquo; volver</a>
    </h4-->

    <form #facturaForm="ngForm" >
      <div class="form-group row" *ngIf="factura.cliente">
        <label for="cliente" class="col-sm-2 col-form-label">Cliente</label>
        <div class="col-sm-6">
          <input type="text" name="cliente" value="{{factura.cliente.nombre}} {{factura.cliente.apellido}}" class="form-control" disabled>
        </div>
      </div>
      <div class="form-group row" *ngIf="factura.cliente">
        <label for="cliente" class="col-sm-2 col-form-label">RUC</label>
        <div class="col-sm-6">
          <input type="text" name="cliente" value="{{factura.cliente.cedula}} " class="form-control" disabled>
        </div>
      </div>
      <div class="form-group row">
        <label for="descripcion" class="col-sm-2 col-form-label">Descripción</label>
        <div class="col-sm-6">
          <input  [disabled]="disabledForm" type="text" name="descripcion" [(ngModel)]="factura.descripcion" class="form-control" required #descripcion="ngModel">
          <div class="alert alert-danger" *ngIf="descripcion.invalid && descripcion.touched || descripcion.invalid && facturaForm.submitted">
            La descripción es requerida.
          </div>
        </div>
      </div>
      <div class="form-group row">
        <label for="observacion" class="col-sm-2 col-form-label">Observación</label>
        <div class="col-sm-6">
          <textarea  [disabled]="disabledForm"  name="observacion" [(ngModel)]="factura.observacion" class="form-control"></textarea>
        </div>
      </div>

      <div class="form-group row">
        <div class="col-sm-6">
          <mat-form-field class="col-12">
            <input [disabled]="disabledForm" type="text" placeholder="Añadir producto" aria-label="Productos" matInput [formControl]="autocompleteControl" [matAutocomplete]="auto">
            <mat-autocomplete #auto="matAutocomplete" [displayWith]="mostrarNombre" (optionSelected)="seleccionarProducto($event)">
              <mat-option *ngFor="let producto of productosFiltrados | async" [value]="producto">
                {{producto.nombre}}
              </mat-option>
            </mat-autocomplete>
          </mat-form-field>
          <div class="alert alert-danger" *ngIf="autocompleteControl.invalid && facturaForm.submitted">
            La factura no puede no tener líneas!.
          </div>
        </div>
      </div>
      <div class="alert alert-info my-4" *ngIf="factura.items.length == 0">
        No hay líneas asignadas para la factura. Debe agregar al menos una!
      </div>
      <table class="table table-striped table-hover table-sm" *ngIf="factura.items.length > 0">
        <thead>
          <tr>
            <th>Producto</th>
            <th>Medida</th>

            <th>Precio</th>
            <th>Existencia</th>

            <th>Cantidad</th>
            <th>Total</th>
            <th>Anular</th>
          </tr>
        </thead>
        <tbody>
          <tr *ngFor="let item of factura.items">
            <td class="col-3">{{item.producto.nombre}}</td>
            <td class="col-2">{{item.producto.medida}}</td>

            <td  class="col-2">{{item.producto.precio}}</td>
            <td>{{item.producto.existente}}</td>

            <td ><input type="number" value="{{item.cantidad}}" class="form-control col-sm-6" (change)="actualizarCantidad(item.producto.id, $event)"></td>
            <td><input type="number" disabled value="{{item.calcularImporte()}}" class="form-control col-sm-6" (change)="actualizarImporte(item.producto.id, $event)"></td>
            <td><button class="btn btn-danger btn-sm" type="button"
              (click)="eliminarItemFactura(item.producto.id)">x</button></td>
          </tr>
        </tbody>
      </table>
      <h5 class="float-right" *ngIf="factura.items.length > 0">Gran Total: <span class="badge badge-secondary">{{factura.calcularGranTotal()}}</span></h5>

      <div class="form-group row">
        <div class="col-sm-6">
          <input  [disabled]="disabledForm" type="submit" (click)="create(facturaForm)" value="Crear Factura" class="btn btn-secondary">
        </div>
      </div>
    </form>

  </div>
</div>
<ng-template #mymodal let-modal>
  <div class="modal-header  text-center">
    <h3 class="modal-title texto_principal" id="modal-basic-title"> 
      <i class="fa fa-exchange" aria-hidden="true"></i> Apertura de Caja:</h3>
  </div>
  <div class="card-body">
    <div class="content col-md-12 justify-content-center">
      <label><strong>Monto inicial</strong></label>
      <div class="row">
        <div class="col-sm-6">
          <input   name="montoinicial" [(ngModel)]="montoinicial" >
        </div>
      </div>
    </div>
  </div>
  <div class="modal-footer">
    <button type="button" class="btn btn-outline-primary btn-sm mr-1" (click)="modal.close('Save click')"
     > <i class="fa fa-floppy-o" aria-hidden="true"></i> Ok</button>
    <button type="button" class="btn btn-outline-danger btn-sm" aria-label="Close"  (click)="modal.dismiss('Cross click')"
   > <i class="fa fa-window-close" aria-hidden="true"  ></i> Cancelar</button>
  </div>
</ng-template>
<ng-template #mymodalcierre let-modal>
  <div class="modal-header  text-center">
    <h3 class="modal-title texto_principal" id="modal-basic-title"> 
      <i class="fa fa-exchange" aria-hidden="true"></i> Cierre de Caja:</h3>
  </div>
  <div class="card-body">
    <div class="content col-md-12 justify-content-center">
      <label><strong>Usuario</strong></label>
      <div class="row">
        <div class="col-sm-6">
          <input   disabled name="montoinicial" [(ngModel)]="cajaAbierta.usuario" >
        </div>
      </div>
    </div>
    <div class="content col-md-12 justify-content-center">
      <label><strong>Efectivo inicial</strong></label>
      <div class="row">
        <div class="col-sm-6">
          <input  disabled name="montoinicial" [(ngModel)]="cajaAbierta.montoinicial" >
        </div>
      </div>
    </div>
    <div class="content col-md-12 justify-content-center">
      <label><strong>Total Ventas en Efectivo</strong></label>
      <div class="row">
        <div class="col-sm-6">
          <input  disabled name="montoinicial" [(ngModel)]="cajaAbierta.ventastotal" >
        </div>
      </div>
    </div>
  </div>
  <div class="card-header">
    <div class="content col-md-12 justify-content-center">
      <label><strong>Total Efectivo en Caja</strong></label>
      <div class="row">
        <div class="col-sm-6">
          <input disabled  name="montoinicial" [(ngModel)]="cajaAbierta.montofinal" >
        </div>
      </div>
    </div>
  </div>
  
  <div class="modal-footer">
    <button type="button" class="btn btn-outline-primary btn-sm mr-1" (click)="modal.close('Save click')"
     > <i class="fa fa-floppy-o" aria-hidden="true"></i> Ok</button>
    <button type="button" class="btn btn-outline-danger btn-sm" aria-label="Close"  (click)="modal.dismiss('Cross click')"
    > <i class="fa fa-window-close" aria-hidden="true"  ></i> Cancelar</button>
  </div>
</ng-template>